clear all
close all
%Loads data from file into workspace.
load logfile1.txt;
Ts=0.02; %Sampling interval
L=length(logfile1);%(Matrix name becomes same as logfile name.)
F=0.5;%First fraction (portion) of logfile to be used for model adaption:
%N=floor(L*F); %N is number of samples used for estimation.
 %Rest used for visual validation.
N=L;
Km = 5 %from tachometer
t=Ts*[1:N]';
u=logfile1(1:N,2);
sm=logfile1(1:N,3);
s = sm/5;
fi=zeros([N-1,3]);
%derivation of s ...ds=(sk-sk-1)/Ts
ds=[diff(s)/Ts]; % N-1 values  

%Least square method
fi= [s(2:N,1),u(2:N,1),ones(N-1,1)];
th= inv(fi.'*fi)*fi.'*ds

%Estimation parameters
T=-1/th(1,1)
K= (T)/th(2,1)
L=(T*th(3,1))/K

%comparation 
sim('simulation.slx')

plot(simout.Time, simout.Data)
title('Real data vs. Simulation')
xlabel('t[s]');
ylabel('S(t),U(t)');
legend('Approximation', 'Real');
