%Finn Haugen (finn@techteach.no)
%21.2 2018
%----------------------------------------------------------
disp('-------------------')
disp('Using fmincon() in Matlab solve an optimization')
disp('(Nonlinear Programming, NLP) problem:')
disp('min_x f(x)')
disp('s.t.')
%----------------------------------------------------------
format compact
clear all
close all
global y_m_prev y_m u_m N
%--------------------------------------------------
%Loads data from file into workspace.
load airheater_logfile.txt;
Ts=0.1; %Sampling interval
L=length(airheater_logfile);%(Matrix name becomes same as logfile name.)
N=L;
t=Ts*[1:N]';
%loading data from the file
u_m=airheater_logfile(1:N,2);
y_m=airheater_logfile(1:N,3); %T_out is y_m
y_m_prev=airheater_logfile(1:N,3); 
% Tout_est= ones([N,1]);
% u= ones([N,1]);


%y_prew 
for i=1:N
 if(i==1)   
    y_m_prev(i)=0;
 else
     y_m_prev(i)=y_m(i-1);
 end;
end;

% if(u(1)==0) 
%     T_env= y_m(1);
% end 
% 
% %time delay estimation
% count=0;
% c =1;
% min = y_m(1)+1;
% while (min>y_m(c))
% count = count+1;
% c = c+1;
% end;
% Td = count*Ts;
%---------------------------------------------------

%Contraints:
K_min=0.1;K_max=2;
Theta_min=0.1;Theta_max=2;
Theta_d_min=1;Theta_d_max=10;
Tenv_min=20;Tenv_max=30;
x_lb=[K_min,Theta_min,Theta_d_min,Tenv_min];
x_ub=[K_max,Theta_max,Theta_d_max,Tenv_max];

%--------------------------------------------------
%fmincon:
x_guess=[0.5,0.2,3,25];
Aineq=[]; Bineq=[]; Aeq=[]; Beq=[];

fun_objective_handle = @(x)fun_objective(x);%Local function
fun_constraints_handle = @(x)fun_constraints(x);%Local function
optim_options=optimset('Display','on');
% optim_options=optimset('Algorithm','sqp','Display','on');
[x_opt,fval,exitflag,output,lambda,grad,hessian] =...
fmincon(fun_objective_handle,x_guess,Aineq,Bineq,Aeq,Beq,x_lb,x_ub,...
    fun_constraints_handle,optim_options);

%--------------------------------------------------
%Displaying the optimal solution:
disp('-------------------')
disp('Optimal solution:')
output
fval
x1_opt=x_opt(1) %Kh optimal
x2_opt=x_opt(2) %Theta optimal
x3_opt=x_opt(3) %Theta_d
x4_opt=x_opt(4) %T_env

%--------------------------------------------------
%Applying the optimal solution:
f_min = (Tout_meas-Tout_est)'*(Tout_meas-Tout_est);
%--------------------------------------------------
%Defining local functions:
%x1 is K, x2 is T, y is Tout_pred
function f = fun_objective(x)
global y_m_prev y_m u_m N
Ts=0.1;
Kh=x(1);
Theta=x(2);
Theta_d = round(x(3)/Ts)+1;
u = u_m(1:N);
u = [u(1)*ones(Theta_d,1); u(1:N-Theta_d)];
Tout_prev = y_m_prev(1:N);
Tout_meas= y_m(1:N);
T_env = (x(4).*ones(length(u),1));
Tout_est =((1-Ts/Theta)*Tout_prev+((Kh*Ts)/Theta).*u)+(Ts/(Theta.*T_env));
%error = Tout_meas-Tout_est;
f = (Tout_meas-Tout_est)'*(Tout_meas-Tout_est);
end

% Defining constraints
function [cineq,ceq]=fun_constraints(x)
cineq = [];  % Compute nonlinear inequalities.
ceq = [];   % Compute nonlinear equalities.
end
