%Finn Haugen (finn@techteach.no)
%21.2 2018
%----------------------------------------------------------
disp('-------------------')
disp('Using fmincon() in Matlab solve an optimization')
disp('(Nonlinear Programming, NLP) problem:')
disp('min_x f(x)')
disp('s.t.')
%----------------------------------------------------------
format compact
clear all
close all
global y_m_prev T_env y_m u
%--------------------------------------------------
%Loads data from file into workspace.
load airheater_logfile.txt;
Ts=0.1; %Sampling interval
L=length(airheater_logfile);%(Matrix name becomes same as logfile name.)
N=L;
t=Ts*[1:N]';

u=airheater_logfile(1:N,2);
y_m=airheater_logfile(1:N,3); %T_out is y_m
y_m_prev=airheater_logfile(1:N,3); 
y = zeros([N,1]);
for i=1:N
 if(i==1)   
    y_m_prew(i)=0;
 else
     y_m_prew(i)=y_m(i-1);
 end;
end;

if(u(1)==0) 
    T_env= y_m(1);
end 

%time delay estimation
count=0;
c =1;
min = y_m(1)+1;
while (min>y_m(c))
count = count+1;
c = c+1;
end;
Td = count*Ts;
%---------------------------------------------------

%Contraints:
K_min=0;K_max=3;
T_min=0.1;T_max=2;
x_lb=[K_min,T_min];
x_ub=[K_max,T_max];

%--------------------------------------------------
%fmincon:
x_guess=[0.5,0.1];
Aineq=[]; Bineq=[]; Aeq=[]; Beq=[];

fun_objective_handle = @(x)fun_objective(x);%Local function
fun_constraints_handle = @(x)fun_constraints(x);%Local function
optim_options=optimset('Display','on');
% optim_options=optimset('Algorithm','sqp','Display','on');
[x_opt,fval,exitflag,output,lambda,grad,hessian] =...
fmincon(fun_objective_handle,x_guess,Aineq,Bineq,Aeq,Beq,x_lb,x_ub,...
    fun_constraints_handle,optim_options);

%--------------------------------------------------
%Displaying the optimal solution:
disp('-------------------')
disp('Optimal solution:')
output
fval
x1_opt=x_opt(1)
x2_opt=x_opt(2)

%--------------------------------------------------
%Applying the optimal solution:
f_min=([y_m-y]'*[y_m-y])

%--------------------------------------------------
%Defining local functions:
%x1 is K, x2 is T, y is Tout_pred
function f = fun_objective(x)
global y_m_prev T_env y_m u
x1=x(1);
x2=x(2);
Ts=0.1;
y_est =((1-Ts/x2)*y_m_prev+((x1*Ts)/x2).*u+Ts/(x2.*T_env));
f = [y_m-y_est]'*[y_m-y_est];
end

% Defining constraints
function [cineq,ceq]=fun_constraints(x)
cineq = [];  % Compute nonlinear inequalities.
% cineq =  -x(2)+x(1)+2;   % Compute nonlinear inequalities.
    %Inequality constraint: x2 >= x1+2
ceq = [];   % Compute nonlinear equalities.
end
